- name: "setup"
  hosts: all
  gather_facts: no
  become: yes
  # https://medium.com/gsoft-tech/easily-configuring-an-azure-devops-agent-with-ansible-fb9cb0f98b73
  # https://github.com/gsoft-inc/ansible-role-azure-devops-agent
  vars:
    - az_devops_accesstoken: "{{ cloudstack.plugins.azure_agent.config.az_devops_accesstoken }}"
    - az_devops_accountname: "{{ cloudstack.plugins.azure_agent.config.az_devops_accountname }}"
    #- az_devops_project_name: null
    - az_devops_agent_version: "{{ cloudstack.plugins.azure_agent.config.az_devops_agent_version }}"
    - az_devops_agent_user: "az_devops_agent"
    - az_devops_agent_group: "az_devops_agent"
    #- az_devops_agent_uid: null
    - az_devops_agent_name: "{{ inventory_hostname }}"
    - az_devops_server_url: "https://dev.azure.com/{{ az_devops_accountname }}"
    #- az_devops_agent_folder: "/home/{{ az_devops_agent_user }}/agent/"
    #- az_devops_work_folder: "/home/{{ az_devops_agent_user }}/agent/_work"
    - az_devops_agent_pool_name: "{{ cloudstack.plugins.azure_agent.config.az_devops_agent_pool_name }}"
    - az_devops_agent_role: "{{ cloudstack.plugins.azure_agent.config.az_devops_agent_role }}"
    #- az_devops_deployment_group_tags: null
    #- az_devops_environment_name: null
    #- az_devops_deployment_group_name: null
    #- az_devops_agent_replace_existing: false
    #- az_devops_reconfigure_agent: false
    #- az_devops_agent_user_capabilities: null
    #- az_devops_proxy_url: null
    #- az_devops_proxy_username: null
    #- az_devops_proxy_password: null
  pre_tasks:
    - name: "preflight"
      include_role:
        name: "/cloudstack/roles/framework/init"

  tasks:
    - name: gather facts
      ansible.builtin.setup:

    - name: create azure user
      user:
        name: "{{ az_devops_agent_user }}"
        groups: "docker"
        generate_ssh_key: true

    - name: get id_rsa.pub
      ansible.builtin.fetch:
        src: "/home/{{ az_devops_agent_user }}/.ssh/id_rsa.pub"
        flat: yes
        dest: ../../{{ inventory_hostname }}_{{ az_devops_agent_user }}_id_rsa.pub

    - name: add ssh-rsa to known_hosts
      known_hosts:
        name: "{{ cloudstack.plugins.azure_agent.config.az_devops_ssh_url }}"
        key: "{{ cloudstack.plugins.azure_agent.config.az_devops_ssh_known_hosts }}"
        path: /etc/ssh/ssh_known_hosts
        # "/home/{{ az_devops_agent_user }}/.ssh/known_hosts"
        state: present

    - name: "azure_agent"
      include_role:
        name: "gsoft.azure_devops_agent"
      with_sequence: start=1 end="{{ cloudstack.plugins.azure_agent.config.agents_per_host }}"
      vars:
        az_devops_agent_folder: "/home/{{ az_devops_agent_user }}/agent-{{ item }}/"
        az_devops_work_folder: "/home/{{ az_devops_agent_user }}/agent-{{ item }}/_work"
        az_devops_agent_name: "{{ inventory_hostname }}-agent-{{ item }}"